' ========================================================================================
' Draw rectangle bar gradient test by franko, 02.feb.2010 :)
' ========================================================================================

#COMPILE EXE
#DIM ALL
#INCLUDE "GDIPLUS.INC"
%IDC_Button = 100
%IDC_GRAPHIC = 101

' =========================================================================================================================================
  FUNCTION WINMAIN (BYVAL hInstance AS DWORD, BYVAL hPrevInstance AS DWORD, BYVAL lpszCmdLine AS ASCIIZ PTR, BYVAL nCmdShow AS LONG) AS LONG
' =========================================================================================================================================
   LOCAL hr AS LONG
   LOCAL hWndMain AS DWORD
   LOCAL hCtl AS DWORD
   LOCAL hFont AS DWORD
   LOCAL wcex AS WndClassEx
   LOCAL szClassName AS ASCIIZ * 80
   LOCAL rc AS RECT
   LOCAL szCaption AS ASCIIZ * 255
   LOCAL nLeft AS LONG
   LOCAL nTop AS LONG
   LOCAL nWidth AS LONG
   LOCAL nHeight AS LONG
   LOCAL token AS DWORD
   LOCAL hDlg AS DWORD
   LOCAL StartupInput AS GdiplusStartupInput

   ' Initialize GDI+
   StartupInput.GdiplusVersion = 1
   hr = GdiplusStartup(token, StartupInput, BYVAL %NULL)
   IF hr THEN
      MSGBOX "Error initializing GDI+"
      EXIT FUNCTION
   END IF

   hFont = GetStockObject(%ANSI_VAR_FONT)

   ' Register the window class
   szClassName        = "MyClassName"
   wcex.cbSize        = SIZEOF(wcex)
   wcex.style         = %CS_HREDRAW OR %CS_VREDRAW
   wcex.lpfnWndProc   = CODEPTR(WndProc)
   wcex.cbClsExtra    = 0
   wcex.cbWndExtra    = 0
   wcex.hInstance     = hInstance
   wcex.hCursor       = LoadCursor (%NULL, BYVAL %IDC_ARROW)
   wcex.hbrBackground = GetStockObject(%WHITE_BRUSH)
   wcex.lpszMenuName  = %NULL
   wcex.lpszClassName = VARPTR(szClassName)
   wcex.hIcon         = LoadIcon (%NULL, BYVAL %IDI_APPLICATION) ' Sample, if resource icon: LoadIcon(hInst, "APPICON")
   wcex.hIconSm       = LoadIcon (%NULL, BYVAL %IDI_APPLICATION) ' Remember to set small icon too..
   RegisterClassEx wcex

   ' Window caption
   szCaption = "bar gradient example"

   ' Retrieve the nSize of the working area
   SystemParametersInfo %SPI_GETWORKAREA, 0, BYVAL VARPTR(rc), 0

   ' Calculate the position and nSize of the window
   nWidth  = (((rc.nRight - rc.nLeft)) + 2) * 0.85   ' 55% of the client screen width
   nHeight = (((rc.nBottom - rc.nTop)) + 2) * 0.80   ' 50% of the client screen height
   nLeft   = ((rc.nRight - rc.nLeft) \ 2) - nWidth \ 2
   nTop    = ((rc.nBottom - rc.nTop) \ 2) - (nHeight \ 2)

   ' Create a window using the registered class
   hWndMain = CreateWindowEx(%WS_EX_CONTROLPARENT, _           ' extended style
                             szClassName, _                    ' window class name
                             szCaption, _                      ' window caption
                             %WS_OVERLAPPEDWINDOW OR _
                             %WS_CLIPCHILDREN, _               ' window style
                             nLeft, _                          ' initial x position
                             nTop, _                           ' initial y position
                             nWidth, _                         ' initial x nSize
                             nHeight, _                        ' initial y nSize
                             %NULL, _                          ' parent window handle
                             0, _                              ' window menu handle
                             hInstance, _                      ' program instance handle
                             BYVAL %NULL)                      ' creation parameters

   ' Show the window
   ShowWindow hWndMain, nCmdShow
   UpdateWindow hWndMain

   ' Message handler loop
   LOCAL Msg AS tagMsg
   WHILE GetMessage(Msg, %NULL, 0, 0)
      IF ISFALSE IsDialogMessage(hWndMain, Msg) THEN
         TranslateMessage Msg
         DispatchMessage Msg
      END IF
   WEND
   ' Shutdown GDI+
   GdiplusShutdown token
   FUNCTION = msg.wParam
END FUNCTION

'
'----------------------------------------------------------------------------------------------------------------
FUNCTION WndProc (BYVAL hWnd AS DWORD, BYVAL wMsg AS DWORD, BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG
'----------------------------------------------------------------------------------------------------------------
   LOCAL hDC AS DWORD
   LOCAL ps AS PAINTSTRUCT
   LOCAL tRect  AS RECT

   SELECT CASE wMsg

      CASE %WM_COMMAND
         SELECT CASE LOWRD(wParam)
            CASE %IDCANCEL
               IF HIWRD(wParam) = %BN_CLICKED THEN
                  SendMessage hWnd, %WM_CLOSE, 0, 0
                  FUNCTION = 0
                  EXIT FUNCTION
               END IF
         END SELECT

      CASE %WM_SYSCOMMAND
         IF (wParam AND &HFFF0) = %SC_CLOSE THEN
            SendMessage hWnd, %WM_CLOSE, 0, 0
            EXIT FUNCTION
         END IF

      CASE %WM_PAINT
         hDC = BeginPaint(hWnd, ps)
         GDIP_SetLineBlend hDC '->
         GetClientRect hWnd, tRect
         SetBkMode hDC, %WHITE_BRUSH '---> or TRANSPARENT
         SetTextColor hDC, %RED
         DrawText hDC, "Hello, simple gradient Windows!", -1, tRect, %DT_SINGLELINE OR %DT_CENTER OR %DT_VCENTER
         EndPaint(hWnd, ps)
        FUNCTION = 1
        EXIT FUNCTION

      CASE %WM_DESTROY
         PostQuitMessage 0
         EXIT FUNCTION
   END SELECT
   FUNCTION = DefWindowProc(hWnd, wMsg, wParam, lParam)
END FUNCTION

' ========================================================================================
 SUB GDIP_SetLineBlend (BYVAL hdc AS DWORD)
' ========================================================================================
   LOCAL hStatus AS LONG
   LOCAL hStatus1 AS LONG
   LOCAL hStatus2 AS LONG
   LOCAL pGraphics AS DWORD
   LOCAL pGraphics1 AS DWORD
   LOCAL pGraphics2 AS DWORD
   LOCAL rc AS RECTF
   LOCAL colorRed AS DWORD
   LOCAL colorBlue AS DWORD
   LOCAL pLinBrush AS DWORD
   DIM   factors(4) AS SINGLE
   DIM   positions(4) AS SINGLE

  '----------------------------------------------- one more rectangle with gradient line at top
   hStatus = GdipCreateFromHDC(hdc, pGraphics)
   rc.x = 5 : rc.y = 5 : rc.Width = 800 : rc.Height = 60  '-----------> here you must change values ! :)
   colorRed = GDIP_ARGB(255, 255, 0, 0)                    '-----------> here you must change values ! :)
   colorBlue = GDIP_ARGB(255, 120, 100, 255)               '-----------> here you must change values ! :)
   factors(0) = 0.0! : factors(1) = 0.2! : factors(2) = 0.4! : factors(3) = 0.8! : factors(4) = 1.0!
   positions(0) = 0.0! : positions(1) = 0.2! : positions(2) = 0.6! : positions(3) = 0.7! : positions(4) = 0.9!

   hStatus = GdipCreateLineBrushFromRect(rc, colorRed, colorBlue, %LinearGradientModeHorizontal, %WrapModeTile, pLinBrush)
   hStatus = GdipSetLineBlend(pLinBrush, factors(0), positions(0), 4)
   hStatus = GdipFillRectangle(pGraphics, pLinBrush, rc.x, rc.y, rc.Width, rc.Height)

  '----------------------------------------------- one more rectangle with gradient line at bottom
   hStatus1 = GdipCreateFromHDC(hdc, pGraphics1)

   rc.x = 5 : rc.y = 460 : rc.Width = 800 : rc.Height = 60 '-----------> here you must change values ! :)
   colorRed = GDIP_ARGB(255, 200, 120, 120)                '-----------> here you must change values ! :)
   colorBlue = GDIP_ARGB(255, 0, 255, 250)                 '-----------> here you must change values ! :)
   factors(0) = 0.0! : factors(1) = 0.3! : factors(2) = 0.5! : factors(3) = 0.9!
   positions(0) = 0.0! : positions(1) = 0.2! : positions(2) = 0.6! : positions(3) = 1.0!

   hStatus1 = GdipCreateLineBrushFromRect(rc, colorRed, colorBlue, %LinearGradientModeHorizontal, %WrapModeTile, pLinBrush)
   hStatus1 = GdipSetLineBlend(pLinBrush, factors(0), positions(0), 4)
   hStatus1 = GdipFillRectangle(pGraphics1, pLinBrush, rc.x, rc.y, rc.Width, rc.Height)

   '----------------------------------------------- one more rectangles gradient line

  '----------------------------------------------- one more rectangle with gradient line at middle area
   hStatus2 = GdipCreateFromHDC(hdc, pGraphics2)

   rc.x = 5 : rc.y = 260 : rc.Width = 800 : rc.Height = 60 '-----------> here you must change values ! :)
   colorRed = GDIP_ARGB(255, 200, 200, 0)                '-----------> here you must change values ! :)
   colorBlue = GDIP_ARGB(255, 100, 125, 255)                 '-----------> here you must change values ! :)
   factors(0) = 0.0! : factors(1) = 0.3! : factors(2) = 0.5! : factors(3) = 0.9!
   positions(0) = 0.0! : positions(1) = 0.2! : positions(2) = 0.6! : positions(3) = 1.0!

   hStatus2 = GdipCreateLineBrushFromRect(rc, colorRed, colorBlue, %LinearGradientModeHorizontal, %WrapModeTile, pLinBrush)
   hStatus2 = GdipSetLineBlend(pLinBrush, factors(0), positions(0), 4)
   hStatus2 = GdipFillRectangle(pGraphics2, pLinBrush, rc.x, rc.y, rc.Width, rc.Height)


   ' // Cleanup
   IF pLinBrush THEN GdipDeleteBrush(pLinBrush)
   IF pGraphics THEN GdipDeleteGraphics(pGraphics)
   IF pGraphics1 THEN GdipDeleteGraphics(pGraphics1)
   IF pGraphics2 THEN GdipDeleteGraphics(pGraphics2)
END SUB
